using GiftShopContracts.BindingModels;
using GiftShopContracts.ViewModels;
using GiftShopDataModels.Enums;
using GiftShopDataModels.Models;
using System.Xml.Linq;

namespace GiftShopFileImplement.Models
{
    internal class Order : IOrderModel
    {
        public int GiftId { get; private set; }

        public int? ImplementerId { get; set; }

        public int ClientId { get; private set; }

        public string GiftName { get; private set; } = string.Empty;

        public int Count { get; private set; }

        public double Sum { get; private set; }

        public OrderStatus Status { get; private set; } = OrderStatus.Неизвестен;

        public DateTime DateCreate { get; private set; } = DateTime.Now;

        public DateTime? DateImplement { get; private set; }

        public int Id { get; private set; }

        public static Order? Create(OrderBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Order()
            {
                Id = model.Id,
                GiftId = model.GiftId,
                GiftName = model.GiftName,
                Count = model.Count,
                ClientId = model.ClientId,
                ImplementerId = model.ImplementerId,
                Sum = model.Sum,
                Status = model.Status,
                DateCreate = model.DateCreate,
                DateImplement = model.DateImplement
            };
        }

        public static Order? Create(XElement element)
        {
            if (element == null)
            {
                return null;
            }
            var order = new Order()
            {
                Id = Convert.ToInt32(element.Attribute("Id")!.Value),
                GiftId = Convert.ToInt32(element.Element("GiftId")!.Value),
                GiftName = element.Element("GiftName")!.Value,
                Count = Convert.ToInt32(element.Element("Count")!.Value),
                Sum = Convert.ToDouble(element.Element("Sum")!.Value),
                ImplementerId = Convert.ToInt32(element.Element("ImplementerId")!.Value),
                ClientId = Convert.ToInt32(element.Element("ClientId")!.Value),
                Status = (OrderStatus)Enum.Parse(typeof(OrderStatus), element.Element("Status")!.Value),
                DateCreate = DateTime.ParseExact(element.Element("DateCreate")!.Value, "G", null)
            };

            DateTime.TryParse(element.Element("DateImplement")!.Value, out DateTime dateImpl);
            order.DateImplement = dateImpl;

            return order;
        }

        public void Update(OrderBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            Status = model.Status;
            DateImplement = model.DateImplement;
        }

        public OrderViewModel GetViewModel => new()
        {
            Id = Id,
            GiftId = GiftId,
            ClientId = ClientId,
            ImplementerId = ImplementerId,
            GiftName = GiftName,
            Count = Count,
            Sum = Sum,
            Status = Status,
            DateCreate = DateCreate,
            DateImplement = DateImplement
        };

        public XElement GetXElement => new("Order",
            new XAttribute("Id", Id),
            new XElement("GiftName", GiftName),
            new XElement("GiftId", GiftId.ToString()),
            new XElement("ClientId", ClientId.ToString()),
            new XElement("ImplementerId", ImplementerId.ToString()),
            new XElement("Count", Count.ToString()),
            new XElement("Sum", Sum.ToString()),
            new XElement("Status", Status.ToString()),
            new XElement("DateCreate", DateCreate.ToString()),
            new XElement("DateImplement", DateImplement.ToString()));
    }
}
